<?php

namespace Teknisa\CADCTB\Services;

use Teknisa\Model\Geral\Entities\Prodfili;
use Teknisa\CADCTB\Factories\Ctb27200RegistroAjustePeriodoBaseFactory;
use Teknisa\Libs\Util\Environment;

class Ctb27200RegistroAjustePeriodoBaseService {
    
    public $entityManager;
    protected $environment;
    protected $nrorg;
    protected $Ctb27200Factory;
    
    public function __construct($entityManager, Environment $environment, Ctb27200RegistroAjustePeriodoBaseFactory $factory, $newCode) {
        $this->entityManager    = $entityManager;
        $this->environment      = $environment;
        $this->Ctb27200Factory  = $factory;
        $this->newCode = $newCode; 
    }
    
    public function saveRegistro($row){
        try{
            if($row['__is_new']){
                $row['NRSEQLALURA'] = $this->newCode->getCodeByTableName('LALURPARTEA', $this->nrorg, 1, 0, true);
            
                $this->Ctb27200Factory->acmInsertLancParteA($row); 
            } else {
                $this->Ctb27200Factory->acmUpdateLancParteA($row);
            }

        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function saveParteA($row){
        try{
            $row['NRORG'] = $nrorg = $this->environment->getNrOrgTrab();
            $adqDadosParteB = $this->adqDadosParteB($row);
            $adqDadosParteA = $this->adqDadosParteA($row);
            if($adqDadosParteA['IDTIPOLANC'] != 'A'){
                $pVRDEBITO = $adqDadosParteA['VRLANCAMENT'];
                $pVRCREDITO = 0;
            }
            else {
                $pVRDEBITO =  0;
                $pVRCREDITO = $adqDadosParteA['VRLANCAMENT'];
            }
            
            if(!empty($adqDadosParteB)){
                $acmDelLalurParteB = $this->Ctb27200Factory->getAcmInsertLalurParteB(
                $adqDadosParteA['CDEMPRESA'],
                $adqDadosParteA['NRSEQLALURA'],
                $adqDadosParteA['DTLANCAMENT'],
                $adqDadosParteA['DTLANCAMENT'],
                $adqDadosParteA['DSHISTLANC'],
                $adqDadosParteB['DTLIMITEUSO'],
                $pVRDEBITO,
                $pVRCREDITO
                );
            }
            
            $this->atualizaSaldoParteB($row['CDEMPRESA'], '', 'N', $row['CDCONTCTBL']);
            
            $row['NRSEQCONTLALURA'] = $this->newCode->getCodeByTableName('CONTASLALURA', $this->nrorg, 1, 0, true);
        
            $InsertContasLalur = $this->Ctb27200Factory->InsertContasLalur($row);
            
            $row['IDRELACAO'] = $adqDadosParteA['IDRELACAO'];
            $row['CDCONTCTBLB'] = $adqDadosParteA['CDCONTCTBLB'];
            
            //$acmUpdateLancParteA = $this->Ctb27200Factory->acmUpdateLancParteA($row); 
            
            $adqDadosParteB = $this->adqDadosParteB($row);
            $adqDadosParteA = $this->adqDadosParteA($row);
            
            //PARTE B (EU ACHO) $this->Ctb27200Factory->execSaldoLalurParteB($row['CDEMPRESA'], $row['CDCONTCTBL']);
            
            $row['VRCDCONTCTBL'] = -1 * $row['VRLANCAMENT'];
            
            $acmUpdateContasLancParteA = $this->Ctb27200Factory->acmUpdateContasLancParteA($row);
            
            $row['NRSEQLANC'] = $this->Ctb27200Factory->getNrseqLanc($row); 
            $row['NRSEQLANCLALURA'] = $this->Ctb27200Factory->getNrseqLanclalura($row); 
            
            $this->Ctb27200Factory->acmInsertLancContas($row);
            
            
		} catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function saveParteB($row){
        try{
            $row['NRORG'] = $nrorg = $this->environment->getNrOrgTrab();
            $this->atualizaSaldoParteB($row['CDEMPRESA'], '', 'N', $row['CDCONTCTBL']);
            $adqDadosParteB = $this->adqDadosParteB($row);
            $adqDadosParteA = $this->adqDadosParteA($row);
            $row['CDCONTCTBLB'] = $adqDadosParteA['CDCONTCTBLB'];
            if($adqDadosParteA['IDTIPOLANC'] != 'A'){
                $pVRDEBITO = $adqDadosParteA['VRLANCAMENT'];
                $pVRCREDITO = 0;
            }
            else {
                $pVRDEBITO =  0;
                $pVRCREDITO = $adqDadosParteA['VRLANCAMENT'];
            }
            if(!empty($adqDadosParteB)){
                $acmDelLalurParteB = $this->Ctb27200Factory->getAcmDelLalurParteB($row);
                $row['NRSEQLALURB'] = $this->Ctb27200Factory->getNrseqLalurb($row);
            }else{
                $row['NRSEQLALURB'] = $this->Ctb27200Factory->getNrseqLalurb($row);
            }
            $UpdateLancParteA = $this->Ctb27200Factory->acmUpdateLancParteA($row);
            $adqDadosParteB = $this->adqDadosParteB($row);
            if($adqDadosParteB == false){
                $adqDadosParteB = array();
                $adqDadosParteB['DTLIMITEUSO']  = null;
            }
            $adqDadosParteA = $this->adqDadosParteA($row);

            $acmInsertLalurParteB = $this->Ctb27200Factory->getAcmInsertLalurParteB($adqDadosParteA, $pVRDEBITO, $pVRCREDITO, $row, $adqDadosParteB);
            
            
            $this->Ctb27200Factory->execSaldoLalurParteB($row['CDEMPRESA'], $row['CDCONTCTBL']);
        
           
            
		} catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function apagaParteB($row){
        try{
            $adqDadosParteB = $this->adqDadosParteB($row);
            $adqDadosParteA = $this->adqDadosParteA($row);
            if(!empty($adqDadosParteB)){
                $acmDelLalurParteB = $this->Ctb27200Factory->getAcmDelLalurParteB($row);
            }
            
            //$this->atualizaParteB($row['CDEMPRESA'], '', 'N', $adqDadosParteA['CDCONTCTBLB']);
         }catch (\Exception $e) {
            throw $e;
        }
    }

    public function atualizaSaldoParteB($cdempresa, $nrseqlalura, $apagaantigo, $cdcontctbl){
        try{
            if($apagaantigo == 'S'){
                $this->apagaParteB($cdempresa, $nrseqlalura);
            }else{
                $stpSaldoLalur = $this->Ctb27200Factory->execSaldoLalurParteB($cdempresa, $cdcontctbl);
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function adqDadosParteB($row){
        try{
            $adqDadosParteB = $this->Ctb27200Factory->getAdqDadosParteB(array(
                    "P_CDEMPRESA" => $row['CDEMPRESA'],
                    "P_NRSEQLALURA" => $row['NRSEQLALURA']
                ));
            return $adqDadosParteB;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function adqContasLancParteA($row){
        try{
            $nrseqlalura = $row['NRSEQLALURA'];
            $adqLancamentosContas = $this->Ctb27200Factory->adqContasLancParteA($nrseqlalura);
            return $adqLancamentosContas;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function adqDadosParteA($row){
        try {
            $adqDadosParteA = $this->Ctb27200Factory->getAdqDadosParteA(array(
                    "P_CDEMPRESA" => $row['CDEMPRESA'],
                    "P_NRSEQLALURA" => $row['NRSEQLALURA']
                ));
            return $adqDadosParteA;
            
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function acmInsertLalurParteB($row){
        try {
            $acmInsertLalurParteB = $this->Ctb27200Factory->getAcmInsertLalurParteB(array(
                "P_CDEMPRESA" => $row['CDEMPRESA'],
                "P_NRSEQLALURA" => $row['NRSEQLALURA']
            ));
            
        }catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function validaHistorico($row){
        try {
            return $selectHistorico = $this->Ctb27200Factory->getHistoricoLancamento(
                $row['CDEMPRESA'], $row['DTLANCCONT'], $row['CDCONTCTBL']
            );
            
        }catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteLancamentos($row){
        try {

            $acmExcluiLancamentosConta = $this->Ctb27200Factory->acmExcluiLancamentosConta($row);
            
            $acmDeleteContasLancParteA = $this->Ctb27200Factory->acmDeleteContasLancParteA($row);
            
            $adqDadosParteA = $this->adqDadosParteA($row);
            
            $row['IDRELACAO'] = $adqDadosParteA['IDRELACAO'];
            $row['CDCONTCTBLB'] = $adqDadosParteA['CDCONTCTBLB'];
            $stpSaldoLalur = $this->Ctb27200Factory->execSaldoLalurParteB($row['CDEMPRESA'], $row['CDCONTCTBL']);
            
        } catch(\Exception $e) {
            throw $e;
        }
    }
   
}